/* Mt[̓e\ */
#define ZMODEM_DEBUG        0


/************************************************************************/
/*                      y|lncdl vgR                       */
/*      Z-MODEM for MPNBBS made by sei-t  Ver1.01  1999/06/16           */
/************************************************************************/
#include    "mpnbbs.h"
#include    "message.h"
#include    "tables.h"


extern  char far    MES6700[];
extern  char far    MES6701[];
extern  char far    MES6702[];
extern  char far    MES6703[];
extern  char        MES6704[];
extern  char        MES6705[];
extern  char        MES6706[];
extern  char        MES6707[];


char HEXTB[] = "0123456789abcdef";


/*** Lt[`FbN ***/
#define ftype_check(c)  (((0 <= (c)) && (18 >= (c))) ? -1 : 0)


/*** gdwLN^𐔒l֕ϊ ***/
#define hex2num(c)      ((isdigit(c)) ? ((c) - 0x30) : (isxdigit(c)) ? (((c) & 0x0F) + 9) : -1)


#define DATA_LEN        1024            /* f[^pPbg̒             */
#define CRC16OK         0               /* CRC-16 ̃`FbNꍇ    */
#define CRC32OK         0xDEBB20E3      /* CRC-32 ̃`FbNꍇ    */


/*
 *  Z-MODEM ̐pR[h
 */
#define ZPAD        '*'                 /* t[擪̎ʃR[h         */
#define ZDLE        0x18                /* GXP[v & R[h      */
#define ZBIN        'A'                 /* oCiwb_ (CRC-16)          */
#define ZBIN32      'C'                 /* oCiwb_ (CRC-32)          */
#define ZHEX        'B'                 /* wLTwb_ (CRC-16)            */

#define ZCRCE       'h'                 /* f[^pPbg̏I             */
#define ZCRCG       'i'                 /* f[^pPbg             */
#define ZCRCQ       'j'                 /* f[^pPbg(ZACKv) */
#define ZCRCW       'k'                 /* f[^pPbg(ZACK҂) */


/*
 *  t[^Cv
 */
#define ZRQINIT     0                   /* ZbV̊Jn                 */
#define ZRINIT      1                   /* 󋵒ʒm                         */
#define ZSINIT      2                   /* ESCw & ATV[PXݒ   */
#define ZACK        3                   /* m艞                         */
#define ZFILE       4                   /* t@C                     */
#define ZSKIP       5                   /* Mt@CXLbv             */
#define ZNAK        6                   /* wb_đv                   */
#define ZABORT      7                   /* M𒆒f               */
#define ZFIN        8                   /* ZbV̏I                 */
#define ZRPOS       9                   /* w FILE |C^]v   */
#define ZDATA       10                  /* f[^]                       */
#define ZEOF        11                  /* f[^]I                   */
#define ZFERR       12                  /* t@Co̓G[             */
#define ZCRC        13                  /* Mt@CCRC`FbN    */
#define ZCHALLENGE  14                  /* ZLeB`FbN             */
#define ZCOMPL      15                  /* R}hIXe[^X           */
#define ZCAN        16
#define ZFREECNT    17                  /* M󂫗e                   */
#define ZCOMMAND    18                  /* MR}h̎s             */


/*
 *  G[R[h
 */
#define TIME_OVER   -1                  /* ^CAEg                     */
#define FRAME_ERR   -2                  /* łȂt[             */
#define CANRCV      -3                  /* CAN abort M                   */
#define CRCERR      -4                  /* CRCG[                        */
#define TRNCERR     -5                  /* ]G[                       */
#define NO_RCV      -6                  /* Mf[^Ȃ (mode=NO_WAIT)  */


/*
 *  Z-MODEM Rg[f[^
 */
typedef struct{
         int    ftype;                  /* t[^Cv                   */
        long    info;                   /* ⑫ (l or tO)        */
} ZHDT;


/*
 *  ZHDT.info ̑e[u
 */
#define ZINFO_NONE      0               /* ⑫Ȃ                     */
#define ZINFO_VAL       1               /* l                             */
#define ZINFO_FLAG      2               /* tO                           */

char ZINFO_TYPE_TABLE[] = {
        ZINFO_FLAG,                     /* 00  ZRQINIT                      */
        ZINFO_FLAG,                     /* 01  ZRINIT                       */
        ZINFO_FLAG,                     /* 02  ZSINIT                       */
        ZINFO_VAL,                      /* 03  ZACK                         */
        ZINFO_FLAG,                     /* 04  ZFILE                        */
        ZINFO_NONE,                     /* 05  ZSKIP                        */
        ZINFO_NONE,                     /* 06  ZNAK                         */
        ZINFO_NONE,                     /* 07  ZABORT                       */
        ZINFO_NONE,                     /* 08  ZFIN                         */
        ZINFO_VAL,                      /* 09  ZRPOS                        */
        ZINFO_VAL,                      /* 10  ZDATA                        */
        ZINFO_VAL,                      /* 11  ZEOF                         */
        ZINFO_NONE,                     /* 12  ZFERR                        */
        ZINFO_VAL,                      /* 13  ZCRC                         */
        ZINFO_VAL,                      /* 14  ZCHALLENGE                   */
        ZINFO_VAL,                      /* 15  ZCOMPL                       */
        ZINFO_NONE,                     /* 16  ZCAN                         */
        ZINFO_NONE,                     /* 17  ZFREECNT                     */
        ZINFO_FLAG                      /* 18  ZCOMMAND                     */
};


/*
 *  ZHDT.info ɎgtO̒`
 *  ZINFO_FLAG ̑t[݂̂Ɏgp
 */
/*** ZRINIT ***/
#define CANFDX      0x00000001          /* SdʐM\                   */
#define CANOVIO     0x00000002          /* DISK I/O ɎM\            */
#define CANFC32     0x00000020          /* M CRC-32 \         */

/*** ZFILE ***/
#define ZCRESUM     0x00000003          /* W[]                   */


/*
 *  e֐̃tO
 */
/*** Z_rxchar() ***/
#define RV_ZDLE         0x0100          /* O ZDLE M               */

/*** Z_header_send() ***/
#define HEX_HEADER  0
#define BIN_HEADER  1

/*** Z_ans_receive() ***/
#define NO_WAIT     0
#define ANS_WAIT    1


/*
 *  ֐vg^Cv錾
 *  ZMODEM_sd()  ZMODEM_rv()  PROTO.H Ő錾
 */
void Z_CANCAN(int);
int Z_rxchar(CH *, int);
void Z_txchar(char, int);
int Z_header_buff_set(CH *, ZHDT *);
int Z_header_buff_get(CH *, ZHDT *);
int Z_header_send(CH *, ZHDT *, int);
int Z_ans_receive(CH *, ZHDT *, int);
void Z_data_send(int, int, char far *, char);
int Z_data_receive(CH *, int *);
void ZMODEM_abort(int);
int ZRINIT_ans_wait(CH *);
int ZMODEM_send_main(CH *, char *, char *, struct stat *);



void Z_CANCAN(int chno)
{
         int    i;

    /*** ZDLET񑗐M CAN abort ɂȂ ***/
    for(i=0 ; i<8 ; i++){
        txchar(ZDLE, chno);
    }
    for(i=0 ; i<10 ; i++){
        txchar(BS, chno);
    }
}



int Z_rxchar(CH *ch, int tmlmt)
{
         int    c;
         int    ZDLEct;

    ZDLEct = 0;
    while(1){
        if(-1 == (c = rxcharT(ch, tmlmt))){
            c = TIME_OVER;
            break;
        }
        else if(ZDLE == c){
            ZDLEct++;
            if(5 <= ZDLEct){
                c = CANRCV;
                break;
            }
        }
        else{
            if(ZDLEct){
                switch(c){
                case ZCRCE:
                case ZCRCG:
                case ZCRCQ:
                case ZCRCW:
                    c |= RV_ZDLE;
                    break;

                default:
                    if(0x40 == (c & 0x60)){
                        c ^= 0x40;
                    }
                    else{
                        c = TRNCERR;
                    }
                    break;
                }
            }
            break;
        }
    }

    return c;
}



void Z_txchar(char c, int chno)
{
    switch(c & 0x7F){
    case 0x10:
    case 0x11:
    case 0x13:
    case 0x18:
        txchar(ZDLE, chno);
        c ^= 0x40;
        break;
    }
    txchar(c, chno);
}



int Z_header_buff_set(CH *ch, ZHDT *Zbf)
{
        char    infotype;

    if(!ftype_check(Zbf->ftype)){
        return FRAME_ERR;
    }

    memclr(ch->strbuf, 5);
    infotype = ZINFO_TYPE_TABLE[Zbf->ftype];

    if(ZINFO_VAL == infotype){
        ch->strbuf[1] = (char)Zbf->info;
        ch->strbuf[2] = (char)((Zbf->info >> 8) & 0xFF);
        ch->strbuf[3] = (char)((Zbf->info >> 16) & 0xFF);
        ch->strbuf[4] = (char)((Zbf->info >> 24) & 0xFF);
    }
    else if(ZINFO_FLAG == infotype){
        ch->strbuf[1] = (char)((Zbf->info >> 24) & 0xFF);
        ch->strbuf[2] = (char)((Zbf->info >> 16) & 0xFF);
        ch->strbuf[3] = (char)((Zbf->info >> 8) & 0xFF);
        ch->strbuf[4] = (char)Zbf->info;
    }
    ch->strbuf[0] = (char)Zbf->ftype;

    return 0;
}



int Z_header_buff_get(CH *ch, ZHDT *Zbf)
{
        char    infotype;

    if(!ftype_check(ch->strbuf[0])){
        return FRAME_ERR;
    }

    infotype = ZINFO_TYPE_TABLE[ch->strbuf[0]];

    if(ZINFO_NONE == infotype){
        Zbf->info = 0L;
    }
    else if(ZINFO_VAL == infotype){
        Zbf->info =   (long)ch->strbuf[4] * 0x1000000
                    + (long)ch->strbuf[3] * 0x10000
                    + (long)ch->strbuf[2] * 0x100
                    + (long)ch->strbuf[1];
    }
    else if(ZINFO_FLAG == infotype){
        Zbf->info =   (long)ch->strbuf[1] * 0x1000000
                    + (long)ch->strbuf[2] * 0x10000
                    + (long)ch->strbuf[3] * 0x100
                    + (long)ch->strbuf[4];
    }
    Zbf->ftype = (int)ch->strbuf[0];

    return 0;
}



int Z_header_send(CH *ch, ZHDT *Zbf, int mode)
{
         int    chno = ch->ch;
         int    i;

    if(Z_header_buff_set(ch, Zbf)){
        return FRAME_ERR;
    }

    if(HEX_HEADER == mode){
        txchar(ZPAD, chno);
        txchar(ZPAD, chno);
        txchar(ZDLE, chno);
        txchar(ZHEX, chno);

        CRCset(ch->strbuf, 5);
        for(i=0 ; i<7 ; i++){
            txchar(HEXTB[ch->strbuf[i] >> 4], chno);
            txchar(HEXTB[ch->strbuf[i] & 0x0F], chno);
        }

        str_send(echoCRLF, chno);
    }
    else if(BIN_HEADER == mode){
        txchar(ZPAD, chno);
        txchar(ZDLE, chno);
        txchar(ZBIN, chno);

        CRCset(ch->strbuf, 5);
        for(i=0 ; i<7 ; i++){
            Z_txchar(ch->strbuf[i], chno);
        }
    }

#if ZMODEM_DEBUG
    Display_out(_Sprintf(ch->strbuf, "ftype:%2d info:%10ld Send\r\n", Zbf->ftype, Zbf->info));
#endif

    return 0;
}



int Z_ans_receive(CH *ch, ZHDT *Zbf, int mode)
{
         int    chno = ch->ch;
         int    ZPADrv;
         int    ZDLEct;
         int    c;
         int    i;
unsigned short  crc = 0;

    /*
     *  wb_̎M҂AZHEX or ZBIN M
     */
    ZPADrv = 0;
    ZDLEct = 0;
    while(1){
        if(NO_WAIT == mode){
            /* Mobt@Ƀf[^Ȃꍇ́AɏI */
            if(-1 == (c = rxcharA(chno))){
                return NO_RCV;
            }
            mode = ANS_WAIT;
        }
        else{
            if(-1 == (c = rxcharT(ch, 10))){
                return TIME_OVER;
            }
        }

        if(ZPAD == c){
            ZPADrv = 1;
            ZDLEct = 0;
        }
        else if(ZDLE == c){
            ZDLEct++;
            if(5 <= ZDLEct){
                return CANRCV;
            }
        }
        else{
            if(ZPADrv && ZDLEct){
                break;
            }
            else{
                ZPADrv = 0;
                ZDLEct = 0;
            }
        }
    }

    /*
     *  t[^Cvƕ⑫M
     */
    if(ZBIN == c){
        for(i=0 ; i<7 ; i++){
            if(0 > (c = Z_rxchar(ch, 10))){
                return c;                   /* G[Ԃ                 */
            }
            ch->strbuf[i] = (char)c;
            crc = CRC((char)c, crc);
        }
        if(CRC16OK != crc){
            return CRCERR;
        }
    }
    else if(ZHEX == c){
        for(i=0 ; i<7 ; i++){
            if(0 > (c = Z_rxchar(ch, 10))){
                return c;
            }
            if(-1 == (c = hex2num(c))){
                return TRNCERR;
            }
            ch->strbuf[i] = (char)c*16;

            if(0 > (c = Z_rxchar(ch, 10))){
                return c;
            }
            if(-1 == (c = hex2num(c))){
                return TRNCERR;
            }
            ch->strbuf[i] += (char)c;

            crc = CRC(ch->strbuf[i], crc);
        }

        if(CRC16OK != crc){
            return CRCERR;
        }
        rxcharT(ch, 10);                    /* CRLF ̓ǂݎ̂              */
        rxcharT(ch, 10);
    }
    else{
        return FRAME_ERR;
    }

    if(Z_header_buff_get(ch, Zbf)){
        return FRAME_ERR;
    }

#if ZMODEM_DEBUG
    Display_out(_Sprintf(ch->strbuf, "ftype:%2d info:%10ld Receive\r\n", Zbf->ftype, Zbf->info));
#endif

    return Zbf->ftype;
}



void Z_data_send(int chno, int len, char far *bf, char term)
{
         int    i;
unsigned short  crc = 0;

    for(i=0 ; i<len ; i++){
        Z_txchar(bf[i], chno);
        crc = CRC(bf[i], crc);
    }

    txchar(ZDLE, chno);
    txchar(term, chno);
    crc = CRC(term, crc);

    Z_txchar(crc >> 8, chno);
    Z_txchar(crc & 0xFF, chno);
}



int Z_data_receive(CH *ch, int *rvsz)
{
         int    rcd;
         int    rvlen;
         int    term;
        char far *wkptr;
unsigned short  crc = 0;
unsigned short  rvcrc;


    wkptr = ch->farwb;
    rvlen = 0;
    while(1){
        if(0 > (rcd = Z_rxchar(ch, 10))){
            return rcd;
        }
        else{
            if(RV_ZDLE & rcd){
                break;
            }
            if(DATA_LEN <= rvlen){          /* I[o[̏ꍇ           */
                return TRNCERR;
            }

            crc = CRC(rcd, crc);
            *wkptr = (char)rcd;
            wkptr++;
            rvlen++;
        }
    }

    term  = rcd & 0xFF;
    crc   = CRC(term, crc);
    *rvsz = rvlen;

    if(0 > (rcd = Z_rxchar(ch, 5))){
        return rcd;
    }
    rvcrc = (unsigned short)rcd << 8;

    if(0 > (rcd = Z_rxchar(ch, 5))){
        return rcd;
    }
    rvcrc |= (rcd & 0xFF);

    if(rvcrc != crc){
        return CRCERR;
    }

    return term;
}



void ZMODEM_abort(int chno)
{
    sleep(2000);
    RVbf_clear(chno);
}



/* Z-MODEM  terminal  HOST    */
long ZMODEM_rv(CH *ch, int fd)
{
         int    chno = ch->ch;
         int    retry;
         int    rcd;
         int    rvsz;
unsigned int    fw_len;
        long    fptr;
        ZHDT    Zbf;


    RVbf_clear(chno);
    sleep(2000);

    /*** ZRQINIT ҂ ***/
    retry = 20;
    while(1){
        if(ZRQINIT == (rcd = Z_ans_receive(ch, &Zbf, ANS_WAIT))){
            break;
        }
        else if(CANRCV == rcd){
            ZMODEM_abort(chno);
            return -1L;
        }
        else{
            retry--;
            if(!retry){
                ZMODEM_abort(chno);
                Z_CANCAN(chno);
                return -1L;
            }
        }
    }

    /*** ZRINIT M  ZFILE ҂ ***/
    if(ZFILE != (rcd = ZRINIT_ans_wait(ch))){
        return -1L;
    }

    Display_out(MES6702);

    /*** ZRPOS M  ZDATA  f[^pPbgM ***/
    fptr = 0L;
    retry = 10;

ZRPOS_retry:                /* f[^đvƂ͂ɂ         */

    if(CANRCV == rcd){
        ZMODEM_abort(chno);
        return -1L;
    }
    else{
        retry--;
        if(!retry){
            ZMODEM_abort(chno);
            Z_CANCAN(chno);
            return -1L;
        }
    }

    Zbf.ftype = ZRPOS;
    Zbf.info  = fptr;
    Z_header_send(ch, &Zbf, BIN_HEADER);

    while(1){
        if(ZDATA == (rcd = Z_ans_receive(ch, &Zbf, ANS_WAIT))){
            if(fptr != Zbf.info){
                goto ZRPOS_retry;
            }
            fptr = Zbf.info;

            while(1){
                if(0 > (rcd = Z_data_receive(ch, &rvsz))){
                    goto ZRPOS_retry;
                }

                wait_file_rush_end(1);
                lseek(fd, fptr, SEEK_SET);
                _dos_write(fd, ch->farwb, rvsz, &fw_len);

                if(rvsz != fw_len){
                    Z_CANCAN(chno);
                    ZMODEM_abort(chno);
                    return -1L;
                }

                fptr += (long)rvsz;
                retry = 10;

                Display_out(_Sprintf(ch->strbuf, MES6707, (long)fptr));

                if(ZCRCW == rcd || ZCRCQ == rcd){
                    Zbf.ftype = ZACK;
                    Zbf.info  = fptr;
                    Z_header_send(ch, &Zbf, BIN_HEADER);
                }

                if(ZCRCW == rcd || ZCRCE == rcd){
                    break;
                }
            }
        }
        else if(ZEOF == rcd){
            if(fptr == Zbf.info){
                break;
            }
        }
        else{
            goto ZRPOS_retry;
        }
    }

    /*** ZRINIT M  ZFIN ҂ ***/
    while(1){
        if(ZFIN == (rcd = ZRINIT_ans_wait(ch))){
            Display_out(MES6703);
            break;
        }
        else if(ZFILE == rcd){
            Zbf.ftype = ZSKIP;
            Z_header_send(ch, &Zbf, HEX_HEADER);
        }
        else if(CANRCV == rcd){
            return -1L;
        }
        else{
            /*
             *  t@C]͊Ă̂ŁAG[NĂ
             *  I
             */
            break;
        }
    }

    return fptr;
}



/*
 *  ZRINIT 𑗐MāAZFILE, ZFIN Ȃǂ̉҂
 */
int ZRINIT_ans_wait(CH *ch)
{
         int    chno = ch->ch;
         int    rcd;
         int    rvsz;
         int    retry;
        ZHDT    Zbf;

    retry = 10;

ZRINIT_retry:

    retry--;
    if(!retry){
        ZMODEM_abort(chno);
        Z_CANCAN(chno);
        return TIME_OVER;
    }

    Zbf.ftype = ZRINIT;
    Zbf.info  = CANFDX | CANOVIO;
    Z_header_send(ch, &Zbf, HEX_HEADER);

    while(1){
        if(ZFILE == (rcd = Z_ans_receive(ch, &Zbf, ANS_WAIT))){
            if(ZCRCW == (rcd = Z_data_receive(ch, &rvsz))){
                return ZFILE;
            }
            else{
                Zbf.ftype = ZNAK;
                Z_header_send(ch, &Zbf, HEX_HEADER);
            }
        }
        else if(ZSINIT == rcd){
            /*** AeVV[PX̑Mv͖ ***/
            rcd = Z_data_receive(ch, &rvsz);
            Zbf.ftype = (ZCRCW == rcd) ? ZACK : ZNAK;
            Zbf.info  = 0L;
            Z_header_send(ch, &Zbf, HEX_HEADER);
        }
        else if(ZFIN == rcd){
            Zbf.ftype = ZFIN;
            Z_header_send(ch, &Zbf, BIN_HEADER);
            ZMODEM_abort(chno);
            return ZFIN;
        }
        else if(CANRCV == rcd){
            ZMODEM_abort(chno);
            return CANRCV;
        }
        else{
            goto ZRINIT_retry;
        }
    }
}



/* Z-MODEM  HOST  terminal */
int ZMODEM_sd(CH *ch, int start)
{
         int    chno = ch->ch;
         int    suu;
         int    sccs;
         int    retry;
         int    rcd;
struct  stat    Fsts;
        char    Tnm[FNAMEMAX+2];
        char    full_path[FNAMEMAX+2];
        TITLEDT Tbf;
        ZHDT    Zbf;


    /*** ZRQINIT M  ZRINIT ҂ ***/
    retry = 10;
    while(1){
        Zbf.ftype = ZRQINIT;
        Zbf.info  = 0L;
        Z_header_send(ch, &Zbf, HEX_HEADER);

        if(ZRINIT == (rcd = Z_ans_receive(ch, &Zbf, ANS_WAIT))){
            break;
        }
        else if(CANRCV == rcd){
            goto ZMODEM_exit;
        }
        else{
            retry--;
            if(!retry){
                Z_CANCAN(chno);
                goto ZMODEM_exit;
            }
        }
    }

    sccs=0;
    for(suu=start ; suu<ch->batchsu ; suu++){
        if(make_file_tables(ch, suu, full_path, Tnm, &Tbf, &Fsts)){
            Z_CANCAN(chno);
            str_send(MES0002, chno);
            goto ZMODEM_exit;
        }

        rcd = ZMODEM_send_main(ch, Tbf.Fname, full_path, &Fsts);

        if(!rcd){                           /* 푗M                     */
            RVbf_clear(chno);
            sccs++;
            DL_count(ch, &boardsys[ch->batch[suu].Bno], Tnm, &Tbf);
            Display_out(MES6701);
        }
        else if(ZSKIP == rcd){
            sccs++;
        }
        else{
            goto ZMODEM_exit;
        }
    }

    /*** ZFIN M  ZFIN ҂  "OO" M ***/
    retry = 10;
    while(1){
        Zbf.ftype = ZFIN;
        Z_header_send(ch, &Zbf, BIN_HEADER);

        if(ZFIN == (rcd = Z_ans_receive(ch, &Zbf, ANS_WAIT))){
            txchar('O', chno);
            txchar('O', chno);
            break;
        }
        else if(CANRCV == rcd){
            goto ZMODEM_exit;
        }
        else{
            retry--;
            if(!retry){
                Z_CANCAN(chno);
                goto ZMODEM_exit;
            }
        }
    }

ZMODEM_exit:
    ZMODEM_abort(chno);
    return sccs;
}



int ZMODEM_send_main(CH *ch, char *Fname, char *full_path, struct stat *Fsts)
{
         int    chno = ch->ch;
        char far *wkptr;
         int    retry;
         int    rcd;
        long    fptr;
         int    rdlen;
         int    term;
         int    recovery;
        ZHDT    Zbf;


    wkptr = ch->farwb;

    make_DL_Fname_block(ch, Fname, Fsts);

    /*** ZFILE M  ZRPOS ҂ ***/
    retry = 10;
    while(1){
        Zbf.ftype = ZFILE;
        Zbf.info  = ZCRESUM;
        Z_header_send(ch, &Zbf, BIN_HEADER);
        Z_data_send(chno, 128, wkptr, ZCRCW);
        Display_out(MES6700);

        if(ZRPOS == (rcd = Z_ans_receive(ch, &Zbf, ANS_WAIT))){
            fptr = Zbf.info;
            break;
        }
        else if(CANRCV == rcd){
            return CANRCV;
        }
        else if(ZSKIP == rcd){
            return ZSKIP;
        }
        else{
            retry--;
            if(!retry){
                Z_CANCAN(chno);
                return TIME_OVER;
            }
        }
    }

    /*** f[^pPbgM ***/
    recovery = 0;

ZDATA_retry:                /* G[ɂđƂ͂ɗ         */

    RVbf_clear(chno);

    Zbf.ftype = ZDATA;
    Zbf.info  = fptr;
    Z_header_send(ch, &Zbf, BIN_HEADER);

    if(recovery){
        term = ZCRCW;
    }
    else{
        term = ZCRCG;
    }

    while(1){
        rdlen = _Ffar_read(full_path, wkptr, DATA_LEN, fptr);
        fptr += (long)rdlen;

        if(Fsts->st_size <= fptr){
            term = ZCRCE;
        }
        else if(0 >= rdlen){
            Z_CANCAN(chno);
            return TRNCERR;
        }

        Z_data_send(chno, rdlen, wkptr, term);

        Display_out(_Sprintf(ch->strbuf, MES6706, (long)fptr));

        if(ZCRCE == term){
            break;
        }

        retry = 10;
        while(1){
            rcd = Z_ans_receive(ch, &Zbf, (ZCRCW == term) ? ANS_WAIT : NO_WAIT);
            if(NO_RCV == rcd){
                break;
            }
            else if(CANRCV == rcd){
                return CANRCV;
            }
            else if(ZRPOS == rcd){          /* f[^G[ɂđv   */
                fptr = Zbf.info;
                recovery = 1;
                goto ZDATA_retry;
            }
            else if(ZACK == rcd){
                if(recovery){               /* f[^G[񕜂ꍇ   */
                    fptr = Zbf.info;
                    recovery = 0;
                    goto ZDATA_retry;
                }
                else{
                    break;                  /* ʏ ZACK ͖         */
                }
            }
            else{
                retry--;
                if(!retry){
                    Z_CANCAN(chno);
                    return TIME_OVER;
                }
            }
        }
    }

    /*** ZEOF M  ZRINIT ҂ ***/
    retry = 10;
    while(1){
        Zbf.ftype = ZEOF;
        Zbf.info  = fptr;
        Z_header_send(ch, &Zbf, BIN_HEADER);

        if(ZRINIT == (rcd = Z_ans_receive(ch, &Zbf, ANS_WAIT))){
            break;
        }
        else if(CANRCV == rcd){
            return CANRCV;
        }
        else if(ZRPOS == rcd){
            /*** f[^̑MIŁAđvꍇ ***/
            fptr = Zbf.info;
            recovery = 1;
            goto ZDATA_retry;
        }
        else{
            retry--;
            if(!retry){
                Z_CANCAN(chno);
                return TIME_OVER;
            }
        }
    }

    return 0;
}



